
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef ivmob_POSTER_LIB_H
#define ivmob_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "ivmobType.h"
#include "ivmobError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[IVMOB_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} IVMOB_CNTRL_STR;

/* For consistency with other posters */
typedef IVMOB_CNTRL_STR IVMOB_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "ivmobPosterLibStruct.h"



/* Posters */
#define IVMOB_CNTRL_POSTER_NAME genomInstanceSuffixName("ivmob", "Cntrl")
#define IVMOB_MEPOS_POSTER_NAME genomInstanceSuffixName("ivmob", "MEPos")
#define IVMOB_ODO_POSTER_NAME genomInstanceSuffixName("ivmob", "Odo")
#define IVMOB_REF_POSTER_NAME genomInstanceSuffixName("ivmob", "Ref")
#define IVMOB_STATUS_POSTER_NAME genomInstanceSuffixName("ivmob", "Status")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS ivmobPosterInit ( void );
extern POSTER_ID ivmobCntrlPosterID ();
extern STATUS ivmobCntrlPosterRead ( IVMOB_CNTRL_STR *ivmobCntrlStrId );
extern STATUS ivmobCntrlPosterInit ( void );
extern STATUS ivmobCntrlInstancePosterRead(const char *name, IVMOB_CNTRL_STR *ivmobCntrlStrId);
extern STATUS ivmobMEPosPosterInit ( void );
extern POSTER_ID ivmobMEPosPosterID ( void );
extern STATUS ivmobMEPosPosterRead ( IVMOB_MEPOS_POSTER_STR *x );
extern STATUS ivmobMEPosInstancePosterRead ( const char *, IVMOB_MEPOS_POSTER_STR * );
extern STATUS ivmobMEPosmePosPosterRead ( POM_ME_POS *mePos );
extern STATUS ivmobMEPosmePosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS ivmobOdoPosterInit ( void );
extern POSTER_ID ivmobOdoPosterID ( void );
extern STATUS ivmobOdoPosterRead ( IVMOB_ODO_POSTER_STR *x );
extern STATUS ivmobOdoInstancePosterRead ( const char *, IVMOB_ODO_POSTER_STR * );
extern STATUS ivmobOdoRobotPosterRead ( GENPOS_CART_STATE *Robot );
extern STATUS ivmobOdoRobotInstancePosterRead( const char *, GENPOS_CART_STATE * );
extern STATUS ivmobOdoVarPosterRead ( GENPOS_CART_CONFIG_VAR *Var );
extern STATUS ivmobOdoVarInstancePosterRead( const char *, GENPOS_CART_CONFIG_VAR * );
extern STATUS ivmobOdoRobot3dPosterRead ( IVMOB_CART_3DSTATE *Robot3d );
extern STATUS ivmobOdoRobot3dInstancePosterRead( const char *, IVMOB_CART_3DSTATE * );
extern STATUS ivmobRefPosterInit ( void );
extern POSTER_ID ivmobRefPosterID ( void );
extern STATUS ivmobRefPosterRead ( IVMOB_REF_POSTER_STR *x );
extern STATUS ivmobRefInstancePosterRead ( const char *, IVMOB_REF_POSTER_STR * );
extern STATUS ivmobRefrefPosterRead ( GENPOS_CART_REF *ref );
extern STATUS ivmobRefrefInstancePosterRead( const char *, GENPOS_CART_REF * );
extern STATUS ivmobStatusPosterInit ( void );
extern POSTER_ID ivmobStatusPosterID ( void );
extern STATUS ivmobStatusPosterRead ( IVMOB_STATUS_POSTER_STR *x );
extern STATUS ivmobStatusInstancePosterRead ( const char *, IVMOB_STATUS_POSTER_STR * );
extern STATUS ivmobStatusstatusPosterRead ( IVMOB_STATUS_STR *status );
extern STATUS ivmobStatusstatusInstancePosterRead( const char *, IVMOB_STATUS_STR * );
extern STATUS ivmobStatusgyroPosterRead ( IVMOB_GYRO *gyro );
extern STATUS ivmobStatusgyroInstancePosterRead( const char *, IVMOB_GYRO * );
#ifdef __cplusplus
}
#endif
#endif

